#We show that the results from package relaimpo,heir.part and dominanceanalysis are identical for multiple regression based on the same data
#the response variable is the first column in fish data. 
#install.packages("hier.part")
library(hier.part)
#example data: urbanwq in hier.part package
data(urbanwq)
env <- urbanwq[,2:8]
#the goodness-of-fit choice for heir.part has to be chosen as R2 (gof= Rsqu)
hier.part(urbanwq$lec, env, fam = "gaussian", gof = "Rsqu")
 
lm.1=lm(urbanwq$lec~.,env)
#install.packages("relaimpo")
library(relaimpo)
calc.relimp(lm.1)
#install.packages('dominanceanalysis')
library(dominanceanalysis)
da<-dominanceAnalysis(lm.1)
summary(da)
#rdacca.hp can work for multiple regression, its result is identical to former packages 
library(rdacca.hp)
rdacca.hp(urbanwq$lec, env,method="RDA", type = "R2")
#An additional advantage of rdacca.hp in relation to former packages is#that it also decomposes adjusted Rsquared for multiple regression
rdacca.hp(urbanwq$lec, env,method="RDA",type = "adjR2")


#the code for rdacca.hp to Doubs fish data
#install rdacca.hp from CRAN or github and load it 
#install.packages('rdacca.hp')
library(rdacca.hp)
#library(devtools)
#install_github('laijiangshan/rdacca.hp')
#sample data in ade4 package
require(ade4)
data(doubs) 
# Fish species as response variables
spe <- doubs$fish
# Environmental factors as explanatory variables
env <- doubs$env
#Remove empty site 8 without species
spe <- spe[-8,]
env <- env[-8,]
# Apart from being a spatial position variable rather than 
# environmental variable, remove the 'dfs' variable (the distance
# from the source) from the 'env' data frame
env <- env[, -1]
# Hellinger-transformation of the species dataset for RDA to deal with the 'double zero' problem
spe.hel <- decostand(spe, "hellinger")
spe.rda <- rda(spe.hel~.,env)
RsquareAdj(spe.rda)
#Variance inflation factors (VIF) in RDA
vif.cca(spe.rda)
# tests for individual variable
anova(spe.rda,by="terms")
#tests for individual variable again after changing order
anova(rda(spe.hel~.,env[,c(2,1,3:10)]),by="terms")
# tests for individual variable
anova(spe.rda,by="mar")
# Forward selection of the variables,setting alpha = 1 to show all variables
library(adespatial)
forward.sel(spe.hel,env,alpha = 1)
#rdacca.hp for variation and hierarchical partitioning
(spe.hp  <- rdacca.hp(spe.hel,env,method="RDA", type="adjR2",var.part=T))
plot(spe.hp)
permu.hp(spe.hel,env, method="RDA", type = "adjR2")

rdacca.hp(spe.hel,env,method="RDA", type="R2",var.part=T)
#conduct a variation portioning and hierarchical partitioning to two sets of matrices containing environmental variables describing 
#river morphology and water quality. Note rdacca.hp has no limit for the number of sets of predictor matrices.
rdacca.hp(spe.hel,list(envtopo=env[,1:3],envchem=env[,4:10]), method="RDA", type = "adjR2",var.part = TRUE)

#example for CCA 
rdacca.hp(spe,env, method="CCA", type = "adjR2",var.part = TRUE)
#example for db-RDA 
rdacca.hp(vegdist(spe),env, method="dbRDA", type = "adjR2",var.part = TRUE)


#show rdacca.hp for mite data with categorical predictors.
library(vegan)
data(mite)
data(mite.env)
#Hellinger-transform the species dataset
mite.hel <- decostand(mite, "hellinger")
rdacca.hp(mite.hel,mite.env,method="RDA",type="adjR2")

rdacca.hp(vegdist(mite),mite.env,method="dbRDA",type="adjR2")
rdacca.hp(mite,mite.env,method="CCA",type="adjR2")

#conduct a variation portioning and hierarchical partitioning for five sets of matrices
data(mite.xy)
data(mite.pcnm)
iv <- list(env1=mite.env[,1:2],env2=mite.env[,3:5],xy=mite.xy,pcnm1=mite.pcnm[,1:7],pcnm2=mite.pcnm[,8:22])
mite.list <- rdacca.hp(mite.hel,iv,method="RDA",var.part = TRUE)
plot(mite.list)
permu.hp(mite.hel,iv,method="RDA")


